<?php
/**
 * FiloBlu srl
 *
 * @category   FiloBlu
 * @package    FiloBlu_ReCaptcha
 * @copyright  FiloBlu srl (http://www.filoblu.com)
 *
 */

namespace FiloBlu\ReCaptcha\Observer\Frontend;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use FiloBlu\ReCaptcha\Api\ValidateInterface;
use FiloBlu\ReCaptcha\Helper\Data;
use Magento\Framework\Message\ManagerInterface;
use Magento\Framework\App\ActionFlag;
use Magento\Framework\Session\SessionManagerInterface;
use Magento\Customer\Model\Url;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Config\ScopeConfigInterface;

class LoginObserver implements ObserverInterface
{
    protected $validateInterface;
    protected $helperData;
    protected $messageManager;
    protected $actionFlag;
    protected $sessionManagerInterface;
    protected $customerUrl;
    protected $scopeConfig;

    public function __construct(
        ValidateInterface $validateInterface,
        Data $helperData,
        ManagerInterface $messageManager,
        SessionManagerInterface $sessionManagerInterface,
        ActionFlag $actionFlag,
        Url $customerUrl,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        $this->validateInterface = $validateInterface;
        $this->helperData = $helperData;
        $this->messageManager = $messageManager;
        $this->sessionManagerInterface = $sessionManagerInterface;
        $this->actionFlag = $actionFlag;
        $this->customerUrl = $customerUrl;
        $this->scopeConfig = $scopeConfig;
    }

    public function execute(Observer $observer)
    {

        $controller = $observer->getControllerAction();

        if (!$this->scopeConfig->getValue('filoblu_recaptcha/settings/customer_account_login')) {
//            $beforeUrl = $this->sessionManagerInterface->getBeforeAuthUrl();
//            $url = $beforeUrl ?: $this->customerUrl->getLoginUrl();
//            $this->actionFlag->set('', Action::FLAG_NO_DISPATCH, true);
//            $controller->getResponse()->setRedirect($url, ['_secure' => true]);
            return;
        }

        if (!$this->validateInterface->validate()) {
            $beforeUrl = $this->sessionManagerInterface->getBeforeAuthUrl();
            $url = $beforeUrl ?: $this->customerUrl->getLoginUrl();

            $this->messageManager->addError($this->helperData->getErrorDescription());
            $this->actionFlag->set('', Action::FLAG_NO_DISPATCH, true);
            $controller->getResponse()->setRedirect($url, ['_secure' => true]);
        }
    }
}
